// Copyright (c) 2015 Milos Jakubicek

#ifndef REGEXOPT_HH
#define REGEXOPT_HH

#include <antlr3.h>
#include <finlib/frstream.hh>
#include "posattr.hh"

FastStream * optimize_regex (PosAttr *a, const char *pat, const char *encoding);
void throwRegexOptException (pANTLR3_BASE_RECOGNIZER recognizer, pANTLR3_UINT8 * tokenNames);

class RegexOptException: public std::exception {
    const std::string _what;
public:
    RegexOptException (const std::string &name)
	:_what ("Regular expression optimization error" + name) {}
    virtual const char* what () const throw () {return _what.c_str();}
    virtual ~RegexOptException() throw() {}
};

#endif
